; 8872 
;   3  LED 
;      

.include "2313def.inc"

.def	PM	=r0

.def	Fmin_hh	=r5	
.def	Fmin_hi	=r6
.def	Fmin_lo	=r7

.def	Fmax_hh	=r8	
.def	Fmax_hi	=r9
.def	Fmax_lo	=r10

.def	st_out	=r11
.def	st_in	=r12

.def	IF_hh	=r13
.def	IF_hi	=r14
.def	IF_lo	=r15

.def	tmp_hh	=r16
.def	tmp_hi	=r17
.def	tmp_lo	=r18

.def	temp	=r19
.def	tmp	=r20
.def	data	=r21

.def	R_UPR	=r22
.def	STAT	=r23
.def	MODE	=r24
.def	Count	=r25

;**         ****
;
.equ	KN_0	=7		;"0" 
.equ	KN_1	=6		;"1" 
.equ	KN_2	=2		;"2"  
.equ	KN_3	=1		;"3"  
.equ	KN_4	=5		;"4"   
.equ	KN_5	=17		;"5"   
.equ	KN_6	=16		;"6"  
.equ	KN_7	=12		;"7"  
.equ	KN_8	=11		;"8"  
.equ	KN_9	=15		;"9" 

.equ	KN_band	=7		;"Band" 
.equ	KN_push	=6		;"Push" 
.equ	KN_b_a	=2		;"B=A"  
.equ	KN_a_b	=1		;"A-B"  
.equ	KN_up	=5		;"up"   
.equ	KN_in	=17		;"in"   
.equ	KN_pop	=16		;"pop"  
.equ	KN_t_r	=12		;"T=R"  
.equ	KN_rit	=11		;"RIT"  
.equ	KN_down	=15		;"down" 

.equ	KN_cw	=18		;"cw"   
.equ	KN_ftr	=8		;"ftr"  
.equ	KN_agc	=14		;"agc"  
.equ	KN_rev	=4		;"rev"  
.equ	KN_att	=19		;"att"  
.equ	KN_ppwr	=9		;"ppwr" 
.equ	KN_esc	=3		;"esc"  
.equ	KN_stc	=13		;"stc"  

.equ	KN_C	=8		;cathode
.equ	KN_A	=14		;anode
;****************************************************
.equ	A0_53	=PB0
.equ	A1_53	=PB1
.equ	WR_53	=PB2
.equ	POWER	=PB2
.equ	IR_CLK	=PB4
.equ	SER	=PB5
.equ	LED_DATA=PB5
.equ	KBD_CLK	=PB5
.equ	IR_DATA	=PB5
.equ	SRCLK	=PB6	
.equ	RCLK	=PB7	

.equ	LED_CLK	=PD0	
.equ	VAL	=PD1
.equ	VAL_INT	=PD2
.equ	KB_INT	=PD3
.equ	KB_0	=PD4
.equ	KB_1	=PD5
.equ	BLINK	=PD6



.equ	mRIT	=0b00000001
.equ	mATT	=0b00000010
.equ	mPPWR	=0b00000100
.equ	mFTR	=0b00001000
.equ	mCW	=0b00010000
.equ	mAGC	=0b00100000
.equ	mREV	=0b01000000
.equ	mKB_RES	=0b10000000
.equ	RIT	=0
.equ	ATT	=1
.equ	PPWR	=2
.equ	FTR	=3
.equ	CW	=4
.equ	AGC	=5
.equ	REV	=6
.equ	KB_RES	=7


.equ	mBUS_0	=0b00000001
.equ	mTX	=0b00000010
.equ	mC_A	=0b00000100

.equ	mW_POP	=0b00100000
.equ	mW_PUSH	=0b01000000
.equ	mW_BND	=0b10000000

.equ	BUS_0	=0
.equ	TX	=1
.equ	C_A	=2
.equ	W_POP	=5
.equ	W_PUSH	=6
.equ	W_BND	=7


;  EEPROM
.equ	AddrC_A	=$7E		; /
.equ	AddrGUN	=$70		;  EEPROM
.equ	AddrIF	=$60		; 
.equ	AddrIFr	=$68		; 

;  SRAM
.equ	Addr_REG=$63		
.equ	AdrR_UPR=$67
.equ	TEST	=$BF

.equ	AdIF_xx	=$0D
.equ	Adtmp_xx=$10


;****************************************************
.ESEG
	;hh  hi  lo reg  
.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db	$0D,$89,$A0,$00,$00,$00,$00,$00,$0D,$8A,$CC,$00,$00,$00,$00,$00
.db	$67,$61,$77,$71,$21,$51,$61,$71,$70,$00,$00,$00,$00,$00,$00,$00	
;   -    - 

;**************************** SRAM ******************
;                 0   1   2   3   4   5   6  7  
;                ............VFO-A..............
;               Fhh Fhi Flo reg Rhh Rhi Rlo R_UPR
;	0060	 00  00  00  00  00  00  00  00  

.DSEG
AdVFO_A:.BYTE 8
AdVFO_B:.BYTE 8       
AddrRet:.BYTE 64	;  
AdTEMP:	.BYTE 4		;    RX (RIT)	

;****************************************************
.CSEG	
	rjmp	RESET
	rjmp	VALCOD	;INT0  
	rjmp	KBINT	;INT1  

;****************************************************
SET_TX:	sbrc	R_UPR,RIT	;  RIT
	rjmp	stx3
	ldi	YL,AdVFO_A	; F  Addr TEMP
	ldi	ZL,AdTEMP
	rcall	Sstx
	ldi	YL,AdVFO_A+4	;    RIT
	ldi	ZL,AdVFO_A	; VFO
	rcall	Sstx
stx3:	sbis	pind,KB_INT		; RX
	rjmp	stx3
	sbrc	R_UPR,RIT	;  RIT
	rjmp	stx1
	ldi	YL,AdTEMP	; F   
	ldi	ZL,AdVFO_A	;
stx2:	rcall	Sstx
stx1:	rjmp	OutInt

Sstx:	ldi	temp,3	
	rcall	VfY_Z		;"Y","Z"
	rcall	RFresh		;"temp"-
	ret
	
MAIN:	sbic	pinb,POWER	;   +5
	rjmp	MAIN
	ldi	temp,0b00000000	;  PB3  OC1
	out	TCCR1A,temp
	out	portb,temp
	out	portd,temp
	sleep			;
	rjmp	MAIN

;****************************************************
;*************    ***********
ktb:	clr	temp
KBINT:	sbic	pind,KB_INT
	rjmp	ktb
	rcall	DELAY
	inc	temp
	brne	KBINT	

	;*       TX
	sbic 	pind,KB_0
	rjmp	kbrd1
	rjmp	kbrd2		;if kb_0=0		
kbrd1:	sbic	pind,KB_1
	rjmp	SET_TX
	cbr	STAT,mBUS_0	;clear flag "BUS_0"
	rjmp	ktn
kbrd2:	sbr	STAT,mBUS_0	;set flag "BUS_0" 
		
;******     *******************
ktn:	sbr	R_UPR,mKB_RES	;   
	rcall	ST_UPR		
	cbr	R_UPR,mKB_RES	;   
	rcall	ST_UPR		
	clr	temp		
	cbi	portb,KBD_CLK
ktn1:	sbi	portb,KBD_CLK
	rcall	DELAY
	cbi	portb,KBD_CLK
	inc	temp
	cpi 	temp,10		; 5618
	breq	ktn	

	sbrc	STAT,BUS_0
	rjmp	ktnb	
	sbic	pind,kb_1	; "1"  1- 
	rjmp	ktn2
	rjmp	ktn1	

ktnb:	sbic	pind,kb_0	; "1"  0- 
	rjmp	ktn2
	rjmp	ktn1

ktn2:	mov	data,temp
	sbr	R_UPR,mKB_RES
	rcall	ST_UPR		;  "0"  
	sbrc	STAT,BUS_0
	rjmp	kjtp	
	ldi	temp,$0A
	add	data,temp	;  1- 

;******      ************
kjtp:	cpi	MODE,0
	breq	kj
	cpi	MODE,$FF
	brne	kinin
	cpi	data,KN_att	; 
	breq	sprg1
	cpi	data,KN_ppwr	; 
	breq	sprg1
	cpi	data,KN_rev	; DIV  
	breq	sprg2
	cpi	data,KN_agc	;  
	breq	sprg3
	cpi	data,KN_ftr	;  
	breq	sprg3
	rjmp	ktbr
sprg3:	mov	MODE,data	;set mode progrmming 
	rjmp	ktii11
sprg2:	mov	MODE,data	;set mode progrmming 
	rcall	ClrRP		;CLR  	
	ldi	temp,$FC
	mov	r5,temp
	ldi	temp,$04
	mov	r3,temp
	clr	count
	ldi	r16,$70
	rcall	Indic		;  
	rjmp	ktbr
sprg1:	mov	MODE,data	;set mode progrmming 
	rcall	ClrRP		;CLR  		
	ldi	tmp_lo,$40
	ldi	tmp_hi,$42
	ldi	tmp_hh,$0F
	ldi	Count,7
	ldi	XL,7
	clr	XH
	ldi	temp,$04	; 
	st	X,temp
	rcall	Indic		;  
	rjmp	ktbr
;****************************************************
kj:	cpi	data,KN_esc	;* "ESC" ******
	brne	kjst
	cbr	STAT,0b11111010
	rcall	TX_ESC	
kesc0:	sbic	pind,KB_INT
	rjmp	ktbrR
	rjmp	kesc0
	
kjst:	sbrc	STAT,W_BND	;  "BAND" 
	rjmp	kinin		
	sbrc	STAT,W_PUSH	;  WAITIN
	rjmp	kinin		
	sbrc	STAT,W_POP	;  WAITOUT
	rjmp	kinin
	rjmp	kin
;****      ******
kinin:	cpi	data,KN_0		;"0"
	brne	ktii0
	ldi	data,0
	ldi	tmp,0
	rjmp	ktii9
ktii0:	cpi	data,KN_1	;"1.9MHz"  or "1"
	brne	ktii1
	ldi	data,1
	ldi	tmp,$04		;EEAdr
	ldi	temp,$00	;Nr BAND
	rjmp	ktii
ktii1:	cpi	data,KN_2	;"3.5" "2"
	brne	ktii2
	ldi	data,2
	ldi	tmp,$08
	ldi	temp,$04
	rjmp	ktii
ktii2:	cpi	data,KN_3		;"7" "3"
	brne	ktii3
	ldi	data,3
	ldi	tmp,$0C
	ldi	temp,$08
	rjmp	ktii
ktii3:	cpi	data,KN_4		;"10" "4"
	brne	ktii4
	ldi	data,4
	ldi	tmp,$10
	ldi	temp,$0C
	rjmp	ktii
ktii4:	cpi	data,KN_5		;"14" "5"
	brne	ktii5
	ldi	data,5
	ldi	tmp,$14
	ldi	temp,$10
	rjmp	ktii
ktii5:	cpi	data,KN_6		;"18" "6"
	brne	ktii6
	ldi	data,6
	ldi	tmp,$18
	ldi	temp,$14
	rjmp	ktii
ktii6:	cpi	data,KN_7		;"21" "7"
	brne	ktii7
	ldi	data,7
	ldi	tmp,$1C
	ldi	temp,$18
	rjmp	ktii
ktii7:	cpi	data,KN_8		;"24" "8"
	brne	ktii8
	ldi	data,8
	ldi	tmp,$20
	ldi	temp,$1C
	rjmp	ktii
ktii8:	cpi	data,KN_9		;"28" "9"
	brne	ktii14
	ldi	data,9
	ldi	tmp,$24
	ldi	temp,$20
	rjmp	ktii
ktii14:	rjmp	ktbr	


ktii:	sbrs	STAT,W_BND	;   "BAND" 	
	rjmp	ktii9
	rcall	Stk_in		;  
	rcall	LdBnd
	lds	R_UPR,AdrR_UPR
	rcall	RFrAll		;All Refresh
	cbr	STAT,mW_BND	;  "BAND" 
	rjmp	ktbr

ktii9:	sbrs	STAT,W_PUSH	;   "PUSH"	
	rjmp	ktii10
	rcall	WrVFO		; EEPROM VFO_A 
	rcall	RFresh		; 
	cbr	STAT,mW_PUSH	;  "PUSH" 
	rjmp	ktbr

ktii10:	sbrs	STAT,W_POP	;   "POP" 	
	rjmp	ktii11
	rcall	Stk_in		;  
	rcall	RrVFOa		; EEPROM
	lds	R_UPR,AdrR_UPR
	rcall	RFrAll		;All Refresh
	cbr	STAT,mW_POP	;  "POP" 

ktii11:	cpi	MODE,KN_agc	; 
	breq	prg_A
	cpi	MODE,KN_ftr	; 
	breq	prg_C
	cpi	MODE,KN_rev		;DIV
	breq	prg2
	cpi	MODE,0
	breq	mktbr
	rjmp	prg1
mktbr:	rjmp	ktbr
prg_A:	ldi	data,$FF
prgC_A:	ldi	tmp,AddrC_A
	rcall	EEWrite
	rjmp	SetPrg
prg_C:	ldi	data,$00
	rjmp	prgC_A

AddIF:	cpi	data,0
	brne	addif0
	ret
addif0:	add	IF_lo,tmp_lo
	adc	IF_hi,tmp_hi
	adc	IF_hh,tmp_hh
	dec	data
	rjmp	addif

prg1:	push	data		;*;/  
	rcall	AddIF		;   "data"
	rcall	DivDec
	pop	data
	rcall	D_7		; D_7 : "data"
	st	X,PM		
	ldi	temp,$04	;
	ld	tmp,-X
	st	X,temp		;  

prg0:	rcall	Indic		
	cpi	XL,0
	breq	wrest
	rjmp	ktbr
	
wrest:	cpi	MODE,KN_att
	brne	wrest0
	rcall	WrIF		; 
	rjmp	forev

wrest0:	cpi	MODE,KN_ppwr
	rcall	WrIFr		;  
	rjmp	forev

prg2:	push	data		;* /  DIV
	rcall	D_7		;: "data" :"PM"
	sbrc	count,0		;/
	rjmp	prg21
	mov	r3,PM		; ()
	mov	r2,mode		; ($04)
	rjmp	prg22
prg21:	mov	r2,PM		; ()
prg22:	mov	data,count
	rcall	Indic		;  
	pop	data
	sbrc	count,0
	rjmp	prg23	
	swap	data
	mov	r17,data
	rjmp	prg24
prg23:	add	data,r17
	mov	tmp,r16
;* : "tmp"        EEPROM 
;* : "data"   
	rcall	EEWrite
	inc	r16
	clr	r2
	mov	r3,mode
	mov	data,r16
	andi	data,0b00001111
	rcall	D_7
	mov	r5,PM
prg24:	inc	count
	cpi	count,20
	breq	forev
	rjmp	ktbr
forev:	rcall	Tx_END
forever:rjmp	forever

;****************************************************
Del:	push	tmp
	ldi	tmp,0
dl1:	rcall	Delay
	dec	tmp
	brne	dl1	
	pop	tmp


Delay:	push	temp
	ldi	temp,0
dl0:	dec	temp
	brne	dl0
	pop	temp
	ret

;**       Fmin_xx  Fmax_xx ***
SetFmm:	ldi	ZL,low(Fm_m*2)	; max  min 
	ldi	ZH,high(Fm_m*2)
	lds	temp,Addr_REG	; 
	andi	temp,0b00001111
	clr	tmp
	swap	temp
	lsr	temp
	add	ZL,temp		;add 
	adc	ZH,tmp
	clr	YH
	ldi	YL,$05		;  
	ldi	tmp,6
sfmm0:	lpm
	adiw	ZL,1		; inc Z
	st	Y+,PM
	dec	tmp
	brne	sfmm0		;
	ret

;****************************************************
F_Minus:rcall	FLoad
	rcall	SetFmm
	sub	Fmin_lo,tmp_lo
	sbc	Fmin_hi,tmp_hi
	sbc	Fmin_hh,tmp_hh
	brcc	F_w
	subi	tmp_lo,$05
	sbci	tmp_hi,$00
	sbci	tmp_hh,$00
	rjmp	F_PM	
F_Plus:	rcall	FLoad
	rcall	SetFmm
	sub	Fmax_lo,tmp_lo
	sbc	Fmax_hi,tmp_hi
	sbc	Fmax_hh,tmp_hh
	brcs	F_w
	subi	tmp_lo,$FB
	sbci	tmp_hi,$FF
	sbci	tmp_hh,$FF
F_PM:	rcall	FSave
	rcall	RFresh
F_w:	ret

;****************************************************
ppval:	sbis	pind,VAL
	rjmp	F_Plus		
	rjmp	F_Minus		;ret  /

valcod:	sbrc	STAT,W_BND	; "W_BAND" 
	rjmp	OutInt		
	sbrc	STAT,W_PUSH	; W_PUSH
	rjmp	OutInt		
	sbrc	STAT,W_POP	; W_POP
	rjmp	OutInt
	cpi	MODE,0		;  
	brne	OutInt
	rcall	ppval



OutInt:	ldi	temp,0b11000000	;*  
	out	GIFR,temp
	reti	

;****************************************************
;*************    ****************

kin:	cpi	data,KN_up	;* "UP" 
	brne	kin1
kinup1:	rcall	F_Plus
	sbic	pind,KB_1	;del +  
	rcall	del
	sbic	pind,KB_INT
	rjmp	ktbrR
	rjmp	kinup1 		; 

kin1:	cpi	data,KN_down	;* "DOWN" 
	brne	kin2
kindn1:	rcall	F_Minus
	sbic	pind,KB_0	;del +  
	rcall	del
	sbic	pind,KB_INT
	rjmp	ktbrR
	rjmp	kindn1

kin2:	cpi	data,KN_band	;* "BAND"	
  	brne	kin3
	sbr	STAT,mW_BND
	rcall	TX_BND
	rjmp	ktbr


kin3:	cpi	data,KN_in	;*** "IN"	
	brne	kin4
	rcall	stk_in
	rjmp	ktbrR	

kin4:	cpi	data,KN_stc	;*** "STC"
	brne	kin5
	rcall	stk_out
	lds	R_UPR,AdrR_UPR
	rcall	RFrAll
	rjmp	ktbr		

kin5:	cpi	data,KN_rit	;*** "RIT"
	brne	kin6
	sbrs	R_UPR,RIT	;  RIT
	rjmp	kcrit
	cbr	R_UPR,mRIT	; RIT
	ldi	YL,AdVFO_A	; F   
	ldi	ZL,AdVFO_A+4	; F  
krit1:	rcall	ST_UPR		; SRAM  74HC595
	ldi	temp,3			
krit0:	rcall	VfY_Z		
	rjmp	ktbrR
kcrit:	sbr	R_UPR,mRIT	; RIT
	ldi	YL,AdVFO_A+4	;   
	ldi	ZL,AdVFO_A	; VFO
	rjmp	krit1

kin6:	cpi	data,KN_t_r	;*** "T=R"
	brne	kin7
	sbr	R_UPR,mRIT
	rcall	ST_UPR			
	rjmp	ktbrR

kin7:	cpi	data,KN_a_b	;*** "A/B"
	brne	kin8
	rcall	Swap
	lds	R_UPR,AdrR_UPR
	rcall	PLS_UPR
	rcall	RFrAll
	rjmp	ktbr

kin8:	cpi	data,KN_push	;*** "PUSH"
	brne	kin9
	lds	temp,AdrR_UPR	; REG1  SRAM
	sbrs	temp,RIT	;  RIT
	rjmp	ktbr
	sbr	STAT,mW_PUSH
	rcall	Tx_IN
	rjmp	ktbr

kin9:	cpi	data,KN_pop	;*** "POP"
	brne	kin10
	sbr	STAT,mW_POP
	rcall	Tx_OUT
	rjmp	ktbr

kin10:	cpi	data,KN_ppwr	;*** "PPWR"
	brne	kin11
	lds	R_UPR,AdrR_UPR
	sbrs	R_UPR,PPWR
	rjmp	kamp1
	cbr	R_UPR,mPPWR
	rjmp	kPLS
kamp1:	sbr	R_UPR,mPPWR
;****************************************************
kPLS:	rcall	ST_UPR	; R_UPR  SRAM  52
	rjmp	ktbrR
;****************************************************
kin11:	cpi	data,KN_att	;*** "ATT"
	brne	kin12
	lds	R_UPR,AdrR_UPR
	sbrs	R_UPR,ATT
	rjmp	katt1
	cbr	R_UPR,mATT
	rjmp	kPLS
katt1:	sbr	R_UPR,mATT
	rjmp	kPLS
	

kin12:	cpi	data,KN_rev	;*** "REV"
	brne	kin13
	lds	R_UPR,AdrR_UPR	; R_UPR  SRAM
	sbrs	R_UPR,REV	; REV
	rjmp	krev1		; REV
	cbr	R_UPR,mREV
	rjmp	kPLS
krev1:	sbr	R_UPR,mREV
	rjmp	kPLS


kin13:	cpi	data,KN_ftr	;*** "FTR"
	brne	kin14
	sbrs	R_UPR,FTR
	rjmp	kftr1
	cbr	R_UPR,mFTR
	rjmp	kPLS
kftr1:	sbr	R_UPR,mFTR
	rjmp	kPLS

kin14:	cpi	data,KN_agc	;*** "AGC"
	brne	kin15
	sbrs	R_UPR,AGC
	rjmp	kagc1
	cbr	R_UPR,mAGC
	rjmp	kPLS
kagc1:	sbr	R_UPR,mAGC
	rjmp	kPLS

kin15:	cpi	data,KN_cw	;*** "CW"
	brne	kin16
	sbrs	R_UPR,CW
	rjmp	kcw1
	cbr	R_UPR,mCW
	rjmp	kPLS
kcw1:	sbr	R_UPR,mCW
	rjmp	kPLS

kin16:	cpi	data,KN_b_a	;*** "B=A"
	brne	ktbr
	rcall	VfoB_A
	rcall	TX_AB
kab0:	sbic	pind,KB_INT
	rjmp	ktbrR
	rjmp	kab0

ktbrR:	rcall	RFresh
ktbr:	rcall	ktbrX		;  
	rjmp	OutInt	

;******    ***************
ktbrX:	clr	temp
ktbr0:	sbis	pind,KB_INT	
	rjmp	ktbrX
	rcall	DELAY
	inc	temp
	brne	ktbr0	;   
	ret

;****************************************************
;****************************************************

;*************    W STACK *******************
;* 3  ,1  REG,3   RIT 
;  1 REG UPR

;* : st_in  st_out       (8 )
Stk_out:ldi	ZL,AdVFO_A	;    
	mov	temp,st_out
	swap	temp
	lsr	temp
	mov	YL,temp
	ldi	temp,$70  	;   W 
	add	YL,temp
	ld	data,Y	
	cpi	data,$AA
	breq	stk1
	ldi	temp,8	;"temp" -
	rcall	VfY_Z	;"Y"  "Z"  
	rcall	RFrAll		;All Refresh
stk1:	mov	temp,st_out
	dec	temp
	andi	temp,0b00000111 ;  8_   
	mov	st_out,temp
	lds	R_UPR,AdrR_UPR
	rcall	PLS_UPR
	ret

;******   W STACK (BAND,POP)******************
Stk_in:	push	temp
	ldi	YL,AdVFO_A	;    RAM 
	ldi	ZL,$70		; W  ()
	mov	temp,st_in	;  
	swap	temp		; 
	lsr	temp
	add	ZL,temp		; +   
	ldi	temp,8		;-    
	rcall	VfY_Z		;   
	mov	st_out,st_in	;  
	mov	temp,st_in	
	inc	temp
	andi	temp,0b00000111	;8  (0,1,2,3..7)
	mov	st_in,temp
	pop	temp
	ret	

;****************************************************
;* : "tmp"        EEPROM 
;* : "data"   
EEWrite:sbic	EECR,EEWE	;if EEWE not clear
	rjmp	EEWrite		;    wait more
	out	EEAR,tmp	;output address
	out	EEDR,data	;output data
	sbi	EECR,EEMWE
	sbi	EECR,EEWE	;set Write strobe
	ret

;****************************************************
;* : "tmp"     EEPROM
;*  tmp_xx      EEPROM
;*  VFO_A    REG    
WrIF:	ldi	tmp,AddrIF	; 
	rjmp	WIF0

WrIFr:	ldi	tmp,AddrIFr	;  ()
WIF0:	ldi	ZL,AdIF_xx
	ldi	temp,3
	rjmp	WrEE0	

WrVFO:	ldi	ZL,AdVFO_A	; VFO_A
	ldi	temp,4

WrEE0:	clr	ZH
WrEE:	ld	data,Z+
	rcall	EEWrite
	inc	tmp
	dec	temp
	brne	WrEE
	ret

;****************************************************
;*  "data"   58053
PLS_53:	ldi	temp,0b11111111	; PB  
	out	DDRB,temp
	cbi	portb,WR_53
	rcall	PLS_595	
	sbi	portb,WR_53
	ldi	temp,0b11111011	;PB2  
	out	DDRB,temp
	ret

;**      74HC595 **************
ST_UPR:	sts	AdrR_UPR,R_UPR	;R_UPR  SRAM
PLS_UPR:
PLS_595:push	data
L595r:	rcall	L595		;"data"  58053
	lds	data,AdrR_UPR
	rcall	L595		; "data"  
	sbi	portb,RCLK	;  
	cbi	portb,RCLK
	cbi	portb,SER
	pop	data
	ret
	
L595:	ldi	temp,8	;  
L595_0:	lsl	data
	brcc	L595_2
	sbi	portb,SER
	rjmp	L595_1
L595_2:	cbi	portb,SER
L595_1:	sbi	portb,SRCLK	; 
	cbi	portb,SRCLK
	dec	temp
	brne	L595_0
	ret

;**  5612   5612  15510 *********		
;*  "temp" -  ,  "data" - 	
IR:	push	data
IR_0:	lsl	data
	brcc	IR_s
	sbi	portb,IR_DATA
	rjmp	IR_1
IR_s:	cbi	portb,IR_DATA
IR_1:	sbi	portb,IR_CLK	; 
	cbi	portb,IR_CLK
	dec	temp
	brne	IR_0	
	pop	data
	ret

;************* / EERead ***************************
;* : "tmp"      EEPROM  "data"
EERead:	sbic	EECR,EEWE	;if EEWE not clear
	rjmp	EERead		;wait more
	out	EEAR,tmp	;address
	sbi	EECR,EERE	;set Read strobe
	sbi	EECR,EERE	;set  strobe 2nd time
	in	data,EEDR	;get data
	ret

;**********   10 ***************************************
;* : tmp_xx 
;* : data      
;* temp=25    --  tmp_xx + 1
;*
dv_2:	rol     data        
        subi    data,10     
        brcc    dv_3       
        subi    data,256-10 
        clc                
        rjmp    dv_1       
dv_3:	sec               
        rjmp    dv_1       
DivDec:	sub     data,data  
        ldi     temp,25    
dv_1:	rol     tmp_lo    
        rol     tmp_hi     
        rol     tmp_hh     
        dec     temp       
        brne    dv_2       
	ret		   

;*********    ***********
;* : "data"  
;* :  "PM"   
D_7:	clr	temp
	ldi	ZH,high(B_COD*2)
	ldi	ZL,low(B_COD*2)
	add	ZL,data
	adc	ZH,temp
	lpm
	ret
	
;****************************************************
BinDec:	rcall	FLoad		; F  tmp_xx
	ldi	YL,2		;  
	clr	YH
	rcall	DivDec		;  10
	mov	tmp,data	; 50
div6:	rcall	DivDec
	rcall	D_7		; 
	cpi	YL,2
	brne	bd1
	cpi	tmp,0		; 50
	breq	bd1
	rjmp	bd2		
bd1:	cpi	YL,3
	brne	bd0
bd2:	mov	temp,PM		; 
	sbr	temp,0b00000001
	mov	PM,temp
bd0:	st	Y+,PM		;   
	cpi	YL,8
	brne	div6

		;************************************
Indic:	ldi	YL,8		;  
	clr	YH
	sbrs	STAT,C_A
	rjmp	ind3
	sbi	portd,BLINK	; ( )
	rjmp	ind4
ind3:	cbi	portd,BLINK	; ( )
ind4:	clt			;  
ind0:	ld	data,-Y		;  
	brts	ind1
	cpi	data,$FC
	breq	ind2
	set	
	rjmp	ind1
ind2:	clr	data
ind1:	rcall	LedTX
	cpi	YL,2
	brne	ind0
	sbrs	STAT,C_A
	rjmp	ind5
	cbi	portd,BLINK	; ( )
	ret
ind5:	sbi	portd,BLINK	; ( )
	ret

;****************************************************
;*  "data"  ,  "temp" - 
LedTX:	ldi	temp,8
LedWW:	ror	data
	brcc	sledt5
	sbrc	STAT,C_A
	rjmp	sledt3
sledt6:	sbi	portb,LED_DATA	;( )
	rjmp	sledt4
sledt5:	sbrc	STAT,C_A
	rjmp	sledt6
sledt3:	cbi	portb,LED_DATA	;( )
sledt4:	sbi	portd,LED_CLK
	cbi	portd,LED_CLK
	dec	temp
	cbi	portb,LED_DATA
	brne	LedWW
	ret

;**********     ***************
;*     "Z"
TX_END:	ldi	ZH,high(TxEND*2)
	ldi	ZL,low(TxEND*2)
	rjmp	OutTX
TX_AB:	ldi	ZH,high(TxAB*2)
	ldi	ZL,low(TxAB*2)
	rjmp	OutTX
TX_ESC:	ldi	ZH,high(TxESC*2)
	ldi	ZL,low(TxESC*2)
	rjmp	OutTX
TX_PRG:	ldi	ZH,high(TxPRG*2)
	ldi	ZL,low(TxPRG*2)
	rjmp	OutTX
TX_OUT:	ldi	ZH,high(TxOUT*2)
	ldi	ZL,low(TxOUT*2)
	rjmp	OutTX
TX_IN:	ldi	ZH,high(TxIN*2)
	ldi	ZL,low(TxIN*2)
	rjmp	OutTX
TX_BND:	ldi	ZH,high(TxBND*2)
	ldi	ZL,low(TxBND*2)
OutTX:	ldi	YL,8
	clr	YH
otx:	lpm
	st	-Y,PM		;   6 
	adiw	ZL,1		;inc Z
	cpi	YL,2
	brne	otx
	rjmp	Indic		;ret in to Indic

;****************************************************
;*  W 
ClrStc:	ldi	ZL,AddrRet
	clr	ZH
	ldi	temp,80
	ldi	tmp,$AA		
	rjmp	clst0
	
;*  
ClrRP:	clr	ZL
	clr	ZH
	ldi	temp,18
clst1:	clr	tmp
clst0:	st	Z+,tmp
	dec	temp
	brne	clst0
	mov	st_in,st_out
	ret

;****************************************************
LdBnd:	ldi	ZH,high(BAND*2)	;a   ROM 
	ldi	ZL,low(BAND*2)
	add	ZL,temp		;+  (+ temp)
	clr	temp
	adc	ZH,temp
	ldi	temp,4
	ldi	YL,AdVFO_A	
	clr	YH
lbnd:	lpm			;  
	adiw	ZL,1		; inc Z
	st	Y+,PM
	dec	temp
	brne	lbnd		;
	ldi	R_UPR,$81	;  
	rcall	ST_UPR
	ret

;****************************************************
;* / "VfoB_A"  VFO_A+REGa   VFO_B+REG1
;* / "FLoad"    VFO_A   tmp_xx 
AddrAB:	ldi	YL,AdVFO_A	;/   
	ldi	ZL,AdVFO_B
	ldi	temp,8		;-  
	ret

VfoB_A:	rcall	AddrAB	
	rjmp	VfY_Z

FSave:	ldi	ZL,AdVFO_A
	ldi	YL,Adtmp_xx
	rjmp	fls0

FLoad:	ldi	YL,AdVFO_A
	ldi	ZL,Adtmp_xx
fls0:	ldi	temp,3
	rjmp	VfY_Z

;* : "temp"   
;* : "Y"   
;* : "Z"  
VfY_Z:	clr	ZH
	clr	YH
fld1:	ld	count,Y+	; 	
	st	Z+,count
	dec	temp
	brne	fld1
	ret

;****************************************************
;* / "Swap"    VFO_A+REG1a  VFO_B+REG1b
Swap:	rcall	AddrAB	;  VFOs
;* : "temp"   
;* : "Y"  1 
;* : "Z"  2
swp:	ld	XL,Y		;  
	ld	XH,Z
	st	Z+,XL
	st	Y+,XH
	dec	temp
	brne	swp
	ret

;****************************************************
;* : "tmp"    1-  EEPROM
;*       EEPROM 
LoadIF:	lds	temp,AdrR_UPR
	sbrs	temp,REV
	rjmp	RdIF
RdIFr:	ldi	tmp,AddrIFr	; ()  IF_
	rjmp	rdif0
RdIF:	ldi	tmp,AddrIF	; ()  IF_
rdif0:	ldi	ZL,AdIF_xx	;    IF_
	clr	ZH
	ldi	temp,3
	rjmp	LrdEE
RrVFOa:	ldi	ZL,AdVFO_A	; VFO_A  SRAM
	rjmp	rdvfo
RrVFOb:	ldi	ZL,AdVFO_B	; VFO_B  SRAM
rdvfo:	clr	ZH
	ldi	temp,4
	
LrdEE:	rcall	EERead
	st	Z+,data
	inc	tmp
	dec	temp
	brne	LrdEE		; 
	ret

;****************************************************
Set_TC1:lds	tmp,Addr_REG	; REG  SRAM 
	andi	tmp,0b00001111	; 
	push	tmp
	clr	data
	ldi	temp,4
	swap	tmp
s_t0:	lsl	tmp
	ror	data
	dec	temp
	brne	s_t0
	ldi	temp,4	;"temp" -  ,	
	rcall	IR	;   10 ()
	pop	tmp
	ldi	temp,AddrGUN	
	add	tmp,temp	; 
	rcall	EERead		;"data"   
	ldi	temp,8

	push	data
	rcall	IR	;     
	pop	data	

;********  Timer/Counter-1 *****************
;  - ,  - 

	andi	data,0b11110000	; 
	ldi	ZH,high(DIV*2)	;  C1  
	ldi	ZL,low(DIV*2)	
	clr	tmp
	lsr	data		;  8
	add	ZL,data		; 
	adc	ZH,tmp		; Z  DIV
	lpm			;  1
	adiw	ZL,1		;inc Z
	out	OCR1AH,PM
	lpm			;  1
	out	OCR1AL,PM
	ret
	
;****************************************************
DPKD:	
	rcall	FLoad
	lds	tmp,Addr_REG	; REG  SRAM
	andi	tmp,0b00001111	; 
	cpi	tmp,4		;(+  -)
	brlo	dpkd0		; ,, +
	sub	tmp_lo,IF_lo	;-
	sbc	tmp_hi,IF_hi
	sbc	tmp_hh,IF_hh
	rjmp	dpkd1
dpkd0:	add	tmp_lo,IF_lo	;+
	adc	tmp_hi,IF_hi
	adc	tmp_hh,IF_hh
dpkd1:	lsl	tmp_lo		;  2
	rol	tmp_hi
	rol	tmp_hh
	rcall	DivDec		;  10
	ldi	temp,5
	ldi	tmp,0
stm2:	lsr	tmp_hh		;  32	
	ror	tmp_hi		
	ror	tmp_lo		
	ror	tmp		
	dec	temp
	brne	stm2
	ror	tmp		; MOD	
	ror	tmp	
	ror	tmp		
	ldi	temp,32		;+32
	add	tmp,temp
	mov	tmp_hh,tmp
	subi	tmp_lo,1	;-32
	sbci	tmp_hi,0
;****    1 2
	cbi	portb,A1_53	;  1
	sbi	portb,A0_53
	mov	data,tmp_lo	; 
	rcall	PLS_53	
	mov	data,tmp_hi	; 
	rcall	PLS_53	
	sbi	portb,A1_53	;  2
	cbi	portb,A0_53
	mov	data,tmp_hh	; 
	rcall	PLS_53	
	cbi	portb,A0_53
	cbi	portb,A1_53
	ret

;****************************************************
RFrAll:	
	rcall	Set_TC1
	rcall	LoadIF
RFresh:	
	rcall	DPKD
	rcall	BinDec
	ret

;****************************************************
;****************************************************

setC_A:	ldi	tmp,AddrC_A
	rcall	EERead
	cpi	data,0
	breq	res1
	ldi	STAT,$04
	ret
res1:	clr	STAT	
	ret
	
RESET:
;******** init Stack Pointer and Other **************		
	ldi	temp,RAMEND	;
	out	SPL,temp	;  
	rcall	setC_A
	rcall	ClrRP	
	ldi	R_UPR,$81

;**********    ****************
	ldi	temp,0b01000001	;PD6,PD0  
	out	DDRD,temp
	ldi	temp,0b11111011	;PB2  
	out	DDRB,temp
	
;********   / 1 ************* 
	ldi	temp,0b01000000	;PB3   OC1
	out	TCCR1A,temp
	ldi	temp,0b00001001 ;  0 
	out	TCCR1B,temp	;  

;*******    53 ************
	sbi	portb,A0_53
	sbi	portb,A1_53
	ldi	data,0b01110110	;T1 Lo,Hi mode 3 Bin
	rcall	PLS_53
	ldi	data,0b10010010	;T2 Lo mode 1 Bin
	rcall 	PLS_53

;***     SLEEP ********
	ldi	temp,0b00111011	;INT 0 ,1 
	out	MCUCR,temp  	; + Power sleep mode
	ldi	temp,0b11000000
	out	GIMSK,temp	;INT0,1 Enable
	out	GIFR,temp	;  INT

;********      *********
	sbis 	pind,kb_0	;
	rjmp	SetPrg				
	sbis	pind,kb_1	;
	rjmp	SetPrg				
	clr	Mode		; 
	rjmp	Next
SetPrg:	rcall	setC_A
	rcall	Tx_PRG		; 
	rcall	ktbrX		;  
	ser	Mode	
	sei			;Global Int Enable
	rjmp	MAIN

;****************************************************
Next:	lds	temp,TEST
	cpi	temp,$AA
	breq	Next0
	rcall	ClrStc
	ldi	temp,$00		
	rcall	LdBnd		;VFO_A  SRAM
	rcall	VfoB_A		
	rcall	Stk_in
Next0:	rcall	RFrAll		;all refresh
	sei			;Global Int Enable
	rjmp	MAIN	

;****************************************************
;****    ************
		; 0   1   2   3   4   5   6   7   8   9  
B_COD:	.db	$FC,$A0,$6E,$E6,$B2,$D6,$DE,$E0,$FE,$F6

;************* F  8001,6  ******************
;****    ,    ************
Fm_m:	.db	$02,$BF,$20,$03,$11,$28	;**  1800.00 2010.00
DIV:	.db	$11,$5D	;**  4445  (900Hz) 
	.db	$05,$53,$48,$05,$D0,$48	;**  3490.00 3810.00
	.db	$13,$89	;**  5001 (800Hz)
	.db	$0A,$AA,$78,$0A,$D9,$58	;**  6990.00 7110.00
	.db	$16,$53	;**  5715  (700Hz)  
	.db	$0F,$3E,$58,$0F,$80,$C0	;**  9990.00 10160.00
	.db	$1A,$0C	;**  6668  (600Hz)
	.db	$15,$58,$D8,$15,$E9,$60	;** 13990.00 14360.00
	.db	$1F,$42	;**  8002  (500Hz)
	.db	$1B,$8D,$E8,$1B,$BC,$C8	;** 18058.00 18168.00
	.db	$27,$12	;**  10002 (400Hz)
	.db	$20,$07,$38,$20,$95,$CC	;** 20990.00 21355.00
	.db	$34,$18	;**  13336 (300Hz)
	.db	$25,$F6,$C0,$26,$25,$A0	;** 24880.00 25000.00
	.db	$4E,$24	;**  20002 (200Hz)
	.db	$2A,$B5,$98,$2D,$55,$78	;** 27990.00 29710.00
;***    *******************
;		hh   hi  lo reg1 
BAND:	.db	$02,$E6,$30,$00	;**  1900.00 MHz
	.db	$05,$88,$04,$01	;**  3500.00
	.db	$0A,$C1,$E8,$02	;**  7050.00
	.db	$0F,$69,$50,$03	;** 10100.00
	.db	$15,$97,$58,$04	;** 14150.00
	.db	$1B,$A6,$20,$05	;** 18120.00
	.db	$20,$59,$40,$06	;** 21200.00
	.db	$25,$FE,$90,$07	;** 24900.00
	.db	$2B,$7C,$D0,$08	;** 28500.00
;*********    ***********************
TxBND:	.db	$00,$9E,$8F,$8A,$AE,$00
TxIN:	.db	$00,$7A,$BC,$D6,$BA,$00
TxOUT:	.db	$00,$00,$7A,$FC,$7A,$00
TxPRG:	.db	$00,$7A,$50,$72,$F6,$00
TxESC:	.db	$00,$00,$5E,$D6,$5C,$00
TxAB:	.db	$00,$00,$9E,$06,$8F,$00
TxEND:	.db	$00,$00,$5E,$8A,$AE,$00

	